"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var EventStoreCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const contract_1 = require("./contract");
const providers_1 = require("./providers");
const cqrs_1 = require("@nestjs/cqrs");
let EventStoreCoreModule = EventStoreCoreModule_1 = class EventStoreCoreModule {
    static register(option) {
        const configProv = {
            provide: contract_1.ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useValue: Object.assign({}, option),
        };
        return {
            module: EventStoreCoreModule_1,
            providers: [configProv],
            exports: [configProv],
        };
    }
    static registerAsync(options) {
        const configProv = {
            provide: contract_1.ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useFactory: async (esOptions) => {
                return Object.assign({}, esOptions);
            },
            inject: [contract_1.NEST_EVENTSTORE_OPTION],
        };
        const asyncProviders = this.createAsyncProviders(options);
        return {
            module: EventStoreCoreModule_1,
            imports: options.imports,
            providers: [
                ...asyncProviders,
                configProv
            ],
            exports: [configProv],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        const useClass = options.useClass;
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: useClass,
                useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: contract_1.NEST_EVENTSTORE_OPTION,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        const inject = [
            (options.useClass || options.useExisting),
        ];
        return {
            provide: contract_1.NEST_EVENTSTORE_OPTION,
            useFactory: async (optionsFactory) => await optionsFactory.createEventStoreOptions(options.name),
            inject,
        };
    }
};
EventStoreCoreModule = EventStoreCoreModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [cqrs_1.CqrsModule],
        providers: [
            ...providers_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...providers_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], EventStoreCoreModule);
exports.EventStoreCoreModule = EventStoreCoreModule;
//# sourceMappingURL=event-store-core.module.js.map