"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const event_store_1 = require("./event-store");
const contract_1 = require("./contract");
const event_store_core_module_1 = require("./event-store-core.module");
const providers_1 = require("./providers");
const explorer_service_1 = require("@nestjs/cqrs/dist/services/explorer.service");
const cqrs_1 = require("@nestjs/cqrs");
let EventStoreModule = class EventStoreModule {
    static register(option) {
        return {
            module: event_store_core_module_1.EventStoreCoreModule,
            imports: [event_store_core_module_1.EventStoreCoreModule.register(option)],
        };
    }
    static registerAsync(option) {
        return {
            module: event_store_core_module_1.EventStoreCoreModule,
            imports: [event_store_core_module_1.EventStoreCoreModule.registerAsync(option)],
        };
    }
    static forFeature(config) {
        if (config === undefined || config === null) {
            throw new Error('Config missing');
        }
        return {
            module: event_store_core_module_1.EventStoreCoreModule,
            providers: [
                explorer_service_1.ExplorerService,
                {
                    provide: contract_1.ProvidersConstants.EVENT_STORE_STREAM_CONFIG_PROVIDER,
                    useValue: Object.assign({}, config),
                },
                event_store_1.EventStore,
            ],
            exports: [
                event_store_1.EventStore,
                explorer_service_1.ExplorerService,
            ],
        };
    }
};
EventStoreModule = __decorate([
    common_1.Module({
        imports: [cqrs_1.CqrsModule],
        providers: [
            ...providers_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...providers_1.eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], EventStoreModule);
exports.EventStoreModule = EventStoreModule;
//# sourceMappingURL=event-store.module.js.map