var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var EventStoreCoreModule_1;
import { Global, Module } from '@nestjs/common';
import { NEST_EVENTSTORE_OPTION, ProvidersConstants } from './contract';
import { eventStoreProviders } from './providers';
import { CqrsModule } from '@nestjs/cqrs';
let EventStoreCoreModule = EventStoreCoreModule_1 = class EventStoreCoreModule {
    static register(option) {
        const configProv = {
            provide: ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useValue: {
                ...option,
            },
        };
        return {
            module: EventStoreCoreModule_1,
            providers: [configProv],
            exports: [configProv],
        };
    }
    static registerAsync(options) {
        const configProv = {
            provide: ProvidersConstants.EVENT_STORE_CONNECTION_CONFIG_PROVIDER,
            useFactory: async (esOptions) => {
                return {
                    ...esOptions,
                };
            },
            inject: [NEST_EVENTSTORE_OPTION],
        };
        const asyncProviders = this.createAsyncProviders(options);
        return {
            module: EventStoreCoreModule_1,
            imports: options.imports,
            providers: [
                ...asyncProviders,
                configProv
            ],
            exports: [configProv],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        const useClass = options.useClass;
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: useClass,
                useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: NEST_EVENTSTORE_OPTION,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        const inject = [
            (options.useClass || options.useExisting),
        ];
        return {
            provide: NEST_EVENTSTORE_OPTION,
            useFactory: async (optionsFactory) => await optionsFactory.createEventStoreOptions(options.name),
            inject,
        };
    }
};
EventStoreCoreModule = EventStoreCoreModule_1 = __decorate([
    Global(),
    Module({
        imports: [CqrsModule],
        providers: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], EventStoreCoreModule);
export { EventStoreCoreModule };
//# sourceMappingURL=event-store-core.module.js.map