var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Module } from '@nestjs/common';
import { EventStore } from './event-store';
import { ProvidersConstants } from './contract';
import { EventStoreCoreModule } from './event-store-core.module';
import { eventStoreProviders } from './providers';
import { ExplorerService } from '@nestjs/cqrs/dist/services/explorer.service';
import { CqrsModule } from '@nestjs/cqrs';
let EventStoreModule = class EventStoreModule {
    static register(option) {
        return {
            module: EventStoreCoreModule,
            imports: [EventStoreCoreModule.register(option)],
        };
    }
    static registerAsync(option) {
        return {
            module: EventStoreCoreModule,
            imports: [EventStoreCoreModule.registerAsync(option)],
        };
    }
    static forFeature(config) {
        if (config === undefined || config === null) {
            throw new Error('Config missing');
        }
        return {
            module: EventStoreCoreModule,
            providers: [
                ExplorerService,
                {
                    provide: ProvidersConstants.EVENT_STORE_STREAM_CONFIG_PROVIDER,
                    useValue: {
                        ...config,
                    },
                },
                EventStore,
            ],
            exports: [
                EventStore,
                ExplorerService,
            ],
        };
    }
};
EventStoreModule = __decorate([
    Module({
        imports: [CqrsModule],
        providers: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
        exports: [
            ...eventStoreProviders,
            {
                provide: 'EVENT_STORE_CONFIG',
                useValue: 'EVENT_STORE_CONFIG_USE_ENV',
            },
        ],
    })
], EventStoreModule);
export { EventStoreModule };
//# sourceMappingURL=event-store.module.js.map